# Contributing to Matano

:+1::tada: First off, thanks for taking the time to contribute! :tada::+1:

We love to receive contributions from our community! There are many ways to contribute, from writing tutorials, improving the documentation, submitting bug reports and feature requests or writing code which can be incorporated into Matano itself.

## Reporting bugs

Did you find a bug?

- Do not open up a GitHub issue if the bug is a security vulnerability and instead to refer to our [security policy][1].
- Ensure the bug was not already reported by searching on GitHub under [Issues][2].
- If you're unable to find an open issue addressing the problem, open a new one. Be sure to include a **title and clear description**, as much relevant information as possible demonstrating the expected behavior that is not occurring.

## Suggesting features/enhancements

Feature requests are welcome.

If you find yourself wishing for a feature that doesn't exist in Matano, you are probably not alone. There are bound to be others out there with similar needs.
Open an issue on our [issues list on GitHub][2] which describes the feature you would like to see, why you need it, and how it should work.

## Pull requests

We welcome code changes and pull requests from the community. Good pull requests - patches, improvements, new features - are a fantastic help.

To get started developing, check out the [DEVELOPMENT.md](DEVELOPMENT.md).

Please ask (feel free to open an issue or send a message in Discord) before embarking on any significant pull request (e.g. implementing features, refactoring code), otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project.

## Community

You can interact with the core team and community on [our Discord channel][3].

[1]: SECURITY.md
[2]: https://github.com/matanolabs/matano/issues
[3]: https://discord.gg/YSYfHMbfZQ
