# Security Policy

We appreciate your help in making Matano secure. We take security issues very seriously and strive to fix all security issues as soon as they're reported.

## Supported Versions

| Version | Supported          |
| ------- | ------------------ |
| All     | :white_check_mark: |

## Reporting a Vulnerability

Please do not open a Github Issue for security issues you encounter. Instead, please send an email to security@matano.dev describing the issue and we'll respond as soon as possible.

You may use the following PGP public key when contacting to report a vulnerability.

<details><summary>Matano PGP Public Key</summary>

```
-----BEGIN PGP PUBLIC KEY BLOCK-----
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=BE9X
-----END PGP PUBLIC KEY BLOCK-----
```

</details>
